"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
const body_data_1 = __importDefault(require("body-data"));
const main_1 = __importDefault(require("./main"));
const utils_1 = require("./utils");
module.exports = async (req, res) => {
    // eslint-disable-next-line no-console
    console.log('NODE.js', process.version);
    // 允许所有域
    res.setHeader('Access-Control-Allow-Origin', '*');
    // 返回json数据
    res.setHeader('Content-Type', 'application/json; charset=utf-8');
    try {
        if (req.url === '/favicon.ico')
            return res.end();
        const data = (await (0, body_data_1.default)(req));
        const projectUrl = 'https://github.com/Lete114/WebStack-Screenshot#%E5%B1%9E%E6%80%A7';
        if (!data.url) {
            const msg = { msg: 'URL not detected , Using parameters: ' + projectUrl };
            return res.end(JSON.stringify(msg));
        }
        const screenshotOpt = (0, utils_1.screenshot)(data); // 截图选项
        const content = await (0, main_1.default)(data);
        // 强制HTTP缓存
        const cacheResult = (0, utils_1.cache)(data.cache);
        if (cacheResult)
            res.setHeader('Cache-Control', cacheResult);
        // 响应base64的img标签
        if (screenshotOpt.encoding === 'base64') {
            const base64 = `data:image/${screenshotOpt.type};base64,${content}`;
            res.setHeader('Content-Type', 'application/json; charset=utf-8');
            res.end(JSON.stringify({ data: base64 }));
        }
        else {
            // 直接响应图片
            res.setHeader('Content-Type', 'image/' + screenshotOpt.type); // 响应图片类型
            res.write(content, screenshotOpt.encoding);
        }
        res.end();
    }
    catch (error) {
        // eslint-disable-next-line
        console.error(error);
        res.end(JSON.stringify({ msg: 'Screenshot failed' }));
    }
};
/* eslint-enable max-statements */
